package ch.zhaw.pm2.racetrack;

import ch.zhaw.pm2.racetrack.given.ConfigSpecification;
import org.junit.Before;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;


public class TrackTest {
    Track trackObj;

    @BeforeEach
    void setup() {
        File file = new File("C:\\Studium\\Semester2\\PM2\\Projekt1\\racetrack\\tracks\\challenge.txt");
        try {
            trackObj = new Track(file);

        } catch (Exception e) {
            System.err.println("Error in Test compareTrack" + e.getMessage());
        }
    }

    @Test
    void canReadFile() {
        File file = new File("C:\\Studium\\Semester2\\PM2\\Projekt1\\racetrack\\tracks\\challenge.txt");
        Assertions.assertThrows(FileNotFoundException.class,() -> new Track(file));
    }

    /**
     * Dirty test...
     */
    @Test
    void printOutTrack() {
        System.out.println(trackObj);
    }

    @Test
    void getSpaceTyp() {
        Assertions.assertEquals(ConfigSpecification.SpaceType.FINISH_RIGHT,trackObj.getSpaceType(new PositionVector(22,24)));
    }

    //TODO:
    @Test
    void addCarAtInit() {
        try {
            trackObj.addCar();
        } catch (InvalidTrackFormatException e) {
            e.printStackTrace();
        }

    }

    @Test
    void findFinish() {
        List<PositionVector> expected = new ArrayList<>();
        expected.add(new PositionVector(22,22));
        expected.add(new PositionVector(22,23));
        expected.add(new PositionVector(22,24));
        Assertions.assertEquals(expected,trackObj.getFinishLine());
    }

    @Test
    void makeTrackObj() {
        try {
            Track t1 = new Track(new File("C:\\Studium\\Semester2\\PM2\\Projekt1\\racetrack\\tracks\\challenge.txt"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (InvalidTrackFormatException e) {
            e.printStackTrace();
        }
    }
}
